"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var get = require("lodash.get");
var Sequence = (function () {
    function Sequence(opts) {
        var _this = this;
        this.createSequenceAction = function (callback) {
            return function () {
                var seqArgs = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    seqArgs[_i] = arguments[_i];
                }
                return function (dispatch, getState) {
                    var proxy = new Proxy(_this, {
                        get: function (target, prop) {
                            var state = get(getState(), target.prefix);
                            if (!state) {
                                throw new Error('invalid state, please check the [prefix]');
                            }
                            if (Reflect.has(state, prop)) {
                                return Reflect.get(state, prop);
                            }
                            if (!target.actions) {
                                throw new Error('invalid actions, please check the [actions]');
                            }
                            if (Reflect.has(target.actions, prop)) {
                                var action_1 = Reflect.get(target.actions, prop);
                                return function () {
                                    var actionArgs = [];
                                    for (var _i = 0; _i < arguments.length; _i++) {
                                        actionArgs[_i] = arguments[_i];
                                    }
                                    return dispatch(action_1.apply(void 0, actionArgs));
                                };
                            }
                        },
                        set: function () {
                            return false;
                        }
                    });
                    return callback.call.apply(callback, [proxy].concat(seqArgs));
                };
            };
        };
        this.setActions = function (actions) {
            _this.actions = actions;
        };
        this.actions = opts.actions;
        this.prefix = opts.prefix;
    }
    return Sequence;
}());
exports.default = Sequence;
